﻿using System;

using System.Drawing;

using System.Windows.Forms;
using Steema.TeeChart.Tools;
using Steema.TeeChart.Drawing;
using Steema.TeeChart;
using System.Diagnostics;



namespace TChart_Sandbox_2
{
    public partial class other : Form
    {
        Steema.TeeChart.Styles.Points points1;
        Steema.TeeChart.Tools.DrawLine drawline1;
        Steema.TeeChart.Tools.DrawLineItem I1;
        Steema.TeeChart.Tools.DrawLineItem I2;
        Steema.TeeChart.Tools.DrawLineItem I3;
        private NearestPoint nearestPoint1; 



        public other()
        {
            InitializeComponent();
            
            ////candle1.FillSampleValues(500);


            points1 = new Steema.TeeChart.Styles.Points(tChart1.Chart);
            //points1.FillSampleValues(100);

            Random rand = new Random();

            for (int x = 1; x < 101; x++)
            {
                
                double? val = 100 * rand.NextDouble();

                points1.Add(val);

            }


            nearestPoint1 = new NearestPoint(points1);
            nearestPoint1.Brush.Color = Color.Blue;
            nearestPoint1.Size = 4;

            

            

            //drawline1 = new Steema.TeeChart.Tools.DrawLine(tChart1.Chart);
            //drawline1.NewLine += new Steema.TeeChart.Tools.DrawLineEventHandler(drawline1_NewLine);

            //I = new Steema.TeeChart.Tools.DrawLineItem(drawline1);
            //int a = tChart1.Tools.Count;
            //double tmp = points1.YValues.Range / 5.0;
            //I.StartPos = new Steema.TeeChart.Drawing.PointDouble(5, points1.YValues.Maximum - tmp);
            //I.EndPos = new Steema.TeeChart.Drawing.PointDouble(15, points1.YValues.Minimum + tmp);

            //drawline1.EnableDraw = false;
            //lbl_drawItemCount.Text = tChart1.Tools.Count.ToString();
        }


        void drawline1_NewLine(Steema.TeeChart.Tools.DrawLine sender)
        {

            drawline1.EnableDraw = false;
            drawline1.NewLine -= new Steema.TeeChart.Tools.DrawLineEventHandler(drawline1_NewLine);
            PointDouble endDPoint = sender.ScreenPoint(sender.ToPoint);
            PointDouble startDPoint = sender.ScreenPoint(sender.FromPoint);

            StartPointLast = startDPoint;
            EndPointLast = endDPoint;

            pointCentre = FindMidPoint(startDPoint, endDPoint);
            theAngle = whatAngle2(startDPoint, endDPoint, true);

            double nAngle = whatAngle2(I1.StartPos, pointCentre, false);
            I1.EndPos = FindExtremeEndpoint(500, nAngle, I1.StartPos);

            I2.StartPos = startDPoint;
            I2EndPoint = FindExtremeEndpoint(500, nAngle, startDPoint);
            I2.EndPos = I2EndPoint;

            I3.StartPos = endDPoint;
            I3EndPoint = FindExtremeEndpoint(500, nAngle, I3.StartPos);
            I3.EndPos = I3EndPoint;
        }

        private int index = 0;

        private void btn_drawLine_Click(object sender, EventArgs e)
        {
            drawline1 = new Steema.TeeChart.Tools.DrawLine(tChart1.Chart);
            drawline1.EnableDraw = true;
            drawline1.NewLine +=new DrawLineEventHandler(drawline1_NewLine);
            drawline1.Select += new DrawLineEventHandler(drawline1_Select);
            drawline1.DragLine += new DrawLineEventHandler(drawline1_DragLine);
            drawline1.EnableSelect = true;

            drawline1.Pen.Width = 2;

            I1 = new DrawLineItem(drawline1);
            I1.Pen.Color = Color.Red;
            I1.Pen.Width = 2;

            I2 = new DrawLineItem(drawline1);
            I2.Pen.Color = Color.Blue;
            I2.Pen.Width = 2;

            I3 = new DrawLineItem(drawline1);
            I3.Pen.Color = Color.MediumPurple;
            I3.Pen.Width = 2;
        }


        private double LineLength1 = 0;
        private double deltaCumLength = 0;
        private double _HandleLength = 10;
        private double tmp_handleLength = 10;
        private int doCount = 0;

        private PointDouble StartPointLast = new PointDouble();
        private PointDouble EndPointLast = new PointDouble();
        private PointDouble pointCentre = new PointDouble(0,0);
        private PointDouble I2EndPoint = new PointDouble(0, 0);
        private PointDouble I3EndPoint = new PointDouble(0, 0);
        private PointDouble HandlePoint = new PointDouble(0, 0);

        void drawline1_DragLine(DrawLine sender)
        {
            int  LineIndex =  WhichLine(sender);
            lbl_lineIndex.Text = LineIndex.ToString();

            //bool StartPointMoving = false;
            //bool EndPointMoving = false;

            //if (StartPointLast.Equals(startDPoint))
            //{
            //    StartPointMoving = false;
            //}
            //else
            //{
            //    StartPointMoving = true;
            //}

            //if (EndPointLast.Equals(endDPoint))
            //{
            //    EndPointMoving = false;
            //}
            //else
            //{
            //    EndPointMoving = true;
            //}

            //cbx_startMoving.Checked = StartPointMoving;
            //cbx_endmoving.Checked = EndPointMoving;


            if (LineIndex == 3)
            {

                PointDouble endDPoint = sender.ScreenPoint(sender.ToPoint);
                PointDouble startDPoint = sender.ScreenPoint(sender.FromPoint);

                StartPointLast = startDPoint;
                EndPointLast = endDPoint;
                
                pointCentre = FindMidPoint(startDPoint, endDPoint);
                theAngle = whatAngle2(startDPoint,endDPoint, true);

                double nAngle = whatAngle2(I1.StartPos, pointCentre, false);
                I1.EndPos = FindExtremeEndpoint(500, nAngle, I1.StartPos);

                I2.StartPos = startDPoint;
                I2EndPoint = FindExtremeEndpoint(500, nAngle, startDPoint);
                I2.EndPos = I2EndPoint;

                I3.StartPos = endDPoint;
                I3EndPoint = FindExtremeEndpoint(500, nAngle, I3.StartPos);
                I3.EndPos = I3EndPoint;


            }
            else if (LineIndex == 0)
            {

                double nAngle = whatAngle2(I1.StartPos, pointCentre, false);
                I1.EndPos = FindExtremeEndpoint(500, nAngle, I1.StartPos);

                I2.StartPos = StartPointLast;
                I2EndPoint = FindExtremeEndpoint(500, nAngle, I2.StartPos);
                I2.EndPos = I2EndPoint;

                I3.StartPos = EndPointLast;
                I3EndPoint = FindExtremeEndpoint(500, nAngle, I3.StartPos);
                I3.EndPos = I3EndPoint;
                
            }
            else if (LineIndex == 1 || LineIndex == 2)
            {
                
                
                I2.StartPos = StartPointLast;
                I2.EndPos = I2EndPoint;

                I3.StartPos = EndPointLast;
                I3.EndPos = I3EndPoint;
            }
            
            
            
            
        }

        private PointDouble FindExtremeEndpoint(double hypot, double angleR, PointDouble start)
        {
            PointDouble pd = new PointDouble();
            pd.X = hypot * Math.Cos(angleR) + start.X;
            pd.Y = hypot * Math.Sin(angleR) + start.Y;

            return pd;
        }
        
        private PointDouble FindMidPoint(PointDouble Start, PointDouble end)
        {
            double midX = ((end.X - Start.X) / 2) + Start.X;
            double midY = ((end.Y - Start.Y)/2) + Start.Y;

            return new PointDouble(midX, midY);
        }
        
        private int WhichLine(DrawLine sender)
        {
            DrawLineItem dItem = sender.Selected;
            return drawline1.Lines.IndexOf(dItem);
        }

        private double LineLength(PointDouble start, PointDouble end)
        {
            double hypotenuse = Math.Sqrt(Math.Pow((end.X - start.X), 2) + Math.Pow((end.Y - start.Y), 2));
            return hypotenuse;
        }

        double theAngle;
        private PointDouble ParallelPoint(PointDouble startPoint, PointDouble endPoint, double Radius, double AngleOffset, bool anEndPoint, double handleLength)
        {
            // The starting point where the cross of the pitchfork is 
            double inX = 0.0;
            double inY = 0.0;

            
            if (anEndPoint)
            {
                inX = startPoint.X;
                inY = startPoint.Y;
            }
            else
            {
                /// Cross Bar at a set proportion i.e. 25%
                //inX = (endPoint.X -  startPoint.X) * 0.25 + startPoint.X;
                //inY = (endPoint.Y -  startPoint.Y) * 0.25 + startPoint.Y;

                /// Cross Bar at set interval ie 30 units.
                inX = handleLength * Math.Cos(theAngle) + startPoint.X;
                inY = handleLength * Math.Sin(theAngle) + startPoint.Y;
            }

            double AngleOffsetRadians = (AngleOffset * Math.PI / 180);

            double outX = inX + Radius * Math.Cos(AngleOffsetRadians + theAngle);
            double outY = inY + Radius * Math.Sin(AngleOffsetRadians + theAngle);

            
            return new PointDouble(outX, outY);
        }

        private double[] FindGradient(PointDouble start, PointDouble end)
        {
            double gradient = (end.Y - start.Y)/(end.X - start.X);
            double c = start.Y - gradient * start.X;

            double[] OutVal = new double[2];
            OutVal[0] = gradient;
            OutVal[1] = c;

            return OutVal;
        }

        private PointDouble FindIntersection(double[] Line1, double[] Line2)
        {
            double m1 = Line1[0];
            double c1 = Line1[1];

            double m2 = Line2[0];
            double c2 = Line1[1];


            double x = (((-1) * c2) - ((-1) * c1)) / ((m1 * (-1)) - (m2 * (-1)));
            double y = ((c1 * m2) - (c2 * m1))/((-1 * m1) - (-1 * m2));

            return new PointDouble(x,y);
        }

        private double whatAngle(PointDouble startPoint, PointDouble endPoint, bool degrees)
        {
            double multiplyer = 1;
            if (degrees)
                multiplyer = 180 / Math.PI;

            double hypotenuse = Math.Sqrt(Math.Pow((endPoint.X - startPoint.X), 2) + Math.Pow((endPoint.Y - startPoint.Y), 2));

            double beta = Math.Asin((endPoint.Y - startPoint.Y) / hypotenuse);
            
            //return Math.Atan((endPoint.Y - startPoint.Y) / (endPoint.X - startPoint.X)) * multiplayer;
            return beta * multiplyer;
        }

        /// <summary>
        /// A better angle that handles -ve quadrants
        /// </summary>
        /// <param name="start"></param>
        /// <param name="end"></param>
        /// <param name="degree"></param>
        /// <returns></returns>
        private double whatAngle2(PointDouble start, PointDouble end, bool degree)
        {
            double x2 = end.X - start.X;
            double y2 = end.Y - start.Y;
            double multiplyer = (degree)? 180 / Math.PI : 1;

            double Angle = Math.Atan2(y2, x2);
           // Angle = (Angle < 0) ? 2 * Math.PI + Angle : Angle;

            return Angle* multiplyer;

        }

        void drawline1_Select(DrawLine sender)
        {
            lbl_lines.Text = sender.Lines.Count.ToString();
            DrawLineItem dItem = sender.Selected;
            lbl_lineIndex.Text = drawline1.Lines.IndexOf(dItem).ToString();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            lbl_tools.Text = tChart1.Tools.Count.ToString();
        }

        private void btn_clear_Click(object sender, EventArgs e)
        {
            tChart1.Tools.Clear();
        }

        private void tChart1_MouseMove(object sender, MouseEventArgs e)
        {
            lbl_valuex.Text =  tChart1.Axes.Bottom.InternalCalcPosPoint(e.X).ToString("N4");
            //lbl_value_y.Text = tChart1.Axes.Left.InternalCalcPosPoint(e.Y).ToString("C");

            lbl_value_y.Text = points1.YScreenToValue(e.Y).ToString("C");
        }

        private void tChart1_MouseUp(object sender, MouseEventArgs e)
        {
            //I2.StartPos = StartPointLast;
            //I2.EndPos = I2EndPoint;

            //I3.StartPos = EndPointLast;
            //I3.EndPos = I3EndPoint;
        }

        DrawLine drawlineA; 
        DrawLine drawlineB; 
        DrawLine drawlineC; 
        DrawLine drawlineD;

        DrawLineItem DLIA;
        DrawLineItem DLIB;
        DrawLineItem DLIC;
        DrawLineItem DLID;
        
        private void btn_pitch_Click(object sender, EventArgs e)
        {
            drawlineA = new DrawLine(tChart1.Chart);
            drawlineA.NewLine += new DrawLineEventHandler(drawlineA_NewLine);
            drawlineA.DragLine += new DrawLineEventHandler(drawlineA_DragLine);
            drawlineA.Pen.Color = Color.Black;
            drawlineA.Pen.Width = 2;

            drawlineB = new DrawLine(tChart1.Chart);
            drawlineB.DragLine += new DrawLineEventHandler(drawlineA_DragLine);
            drawlineB.DraggedLine += new DrawLineEventHandler(drawlineA_DraggedLine);
            drawlineB.Pen.Color = Color.Red;
            drawlineB.Pen.Width = 2;
            drawlineB.EnableDraw = false;
            DLIB = new DrawLineItem(drawlineB);

            drawlineC = new DrawLine(tChart1.Chart);
            drawlineC.EnableSelect = false;
            drawlineC.Pen.Color = Color.Blue;
            drawlineC.Pen.Width = 2;
            drawlineC.EnableDraw = false;
            DLIC = new DrawLineItem(drawlineC);

            drawlineD = new DrawLine(tChart1.Chart);
            drawlineD.EnableSelect = false;
            drawlineD.Pen.Color = Color.Purple;
            drawlineD.Pen.Width = 2;
            drawlineD.EnableDraw = false;
            DLID = new DrawLineItem(drawlineD);
        }

        PointDouble DrawLnAStart;
        PointDouble DrawLnAEnd;
        PointDouble PCentre;
        PointDouble DrawLnBStart;
        
        void drawlineA_DragLine(DrawLine sender)
        {
            if (sender == drawlineA)
            {
                PointDouble endDPoint = DrawLnAEnd = sender.ScreenPoint(sender.ToPoint);
                PointDouble startDPoint = DrawLnAStart = sender.ScreenPoint(sender.FromPoint);

                PCentre = FindMidPoint(startDPoint, endDPoint);

                DLIB.StartPos = DrawLnBStart;
                double angle = whatAngle2(DLIB.StartPos, PCentre, false);
                DLIB.EndPos = FindExtremeEndpoint(500, angle, DLIB.StartPos);

                DLIC.StartPos = startDPoint;
                DLIC.EndPos = FindExtremeEndpoint(500, angle, DLIC.StartPos);

                DLID.StartPos = endDPoint;
                DLID.EndPos = FindExtremeEndpoint(500, angle, DLID.StartPos);
            }
            else if (sender == drawlineB)
            {
                DrawLnBStart =  sender.ScreenPoint(sender.FromPoint);
                
                double angle = whatAngle2(DLIB.StartPos, PCentre, false);
                DLIB.EndPos = FindExtremeEndpoint(500, angle, DLIB.StartPos);

                DLIC.StartPos = DrawLnAStart;
                DLIC.EndPos = FindExtremeEndpoint(500, angle, DLIC.StartPos);

                DLID.StartPos = DrawLnAEnd;
                DLID.EndPos = FindExtremeEndpoint(500, angle, DLID.StartPos);

            }
        }

        void drawlineA_DraggedLine(DrawLine sender)
        {
            if (sender == drawlineA)
            {
                PointDouble endDPoint = DrawLnAEnd = sender.ScreenPoint(sender.ToPoint);
                PointDouble startDPoint = DrawLnAStart = sender.ScreenPoint(sender.FromPoint);

                PCentre = FindMidPoint(startDPoint, endDPoint);

                DLIB.StartPos = DrawLnBStart;
                double angle = whatAngle2(DLIB.StartPos, PCentre, false);
                DLIB.EndPos = FindExtremeEndpoint(500, angle, DLIB.StartPos);

                DLIC.StartPos = startDPoint;
                DLIC.EndPos = FindExtremeEndpoint(500, angle, DLIC.StartPos);

                DLID.StartPos = endDPoint;
                DLID.EndPos = FindExtremeEndpoint(500, angle, DLID.StartPos);
            }
            else if (sender == drawlineB)
            {
                DLIB.StartPos = DrawLnBStart;
                double angle = whatAngle2(DLIB.StartPos, PCentre, false);
                DLIB.EndPos = FindExtremeEndpoint(500, angle, DLIB.StartPos);

                DLIC.StartPos = DrawLnAStart;
                DLIC.EndPos = FindExtremeEndpoint(500, angle, DLIC.StartPos);

                DLID.StartPos = DrawLnAEnd;
                DLID.EndPos = FindExtremeEndpoint(500, angle, DLID.StartPos);
            }
        }

        void drawlineA_NewLine(DrawLine sender)
        {
            drawlineA.EnableDraw = false;
            drawlineA.NewLine -= new DrawLineEventHandler(drawlineA_NewLine);

            PointDouble endDPoint = DrawLnAEnd = sender.ScreenPoint(sender.ToPoint);
            PointDouble startDPoint = DrawLnAStart = sender.ScreenPoint(sender.FromPoint);

            PCentre = FindMidPoint(startDPoint, endDPoint);

            DLIB.StartPos = DrawLnBStart = new PointDouble(10, 10);
            double angle = whatAngle2(DLIB.StartPos, PCentre, false);
            DLIB.EndPos = FindExtremeEndpoint(500, angle, DLIB.StartPos);

            DLIC.StartPos = startDPoint;
            DLIC.EndPos = FindExtremeEndpoint(500, angle, DLIC.StartPos);

            DLID.StartPos = endDPoint;
            DLID.EndPos = FindExtremeEndpoint(500, angle, DLID.StartPos);

        }
    }
}
